#ifndef NAV_H
#define NAV_H


#define MIN_ERROR_HEADING (5.)
#define MIN_ERROR_HEADING_CAPTURE (2)  //more accurate for turn to heading and capture
#define MIN_ERROR_TRANSLATION (.5)
#define SPEED_CHANGE (80.)
#define SPEED_CHANGE_HEADING (50.)
#define SPEED_CHANGE_HEADING_CAPTURE (60.)
#define MIN_HEADING_MAP (44.)

#define HEADING_GAIN_PROPORTIONAL (1.25);
#define HEADING_GAIN_INTEGRAL (0);
#define HEADING_GAIN_DERIVATIVE (0);

#define VELOCITY_GAIN_PROPORTIONAL (-1.4); //(-1.75);  if going center to center
#define VELOCITY_GAIN_INTEGRAL (0);
#define VELOCITY_GAIN_DERIVATIVE (0);

struct Point me;
struct Point goal;

uint32_t lastTime;

bool headingSelect;

float map(float x, float in_min, float in_max, float out_min, float out_max);

float to_degrees(float rad);

float goal_heading(void);

void update_goal(long int x, long int y);

float line_dist(void);

void recalibrate(void);

void update_motors_capture(void);

void update_motors_heading(void);

void update_motors(void);

void update_all(long int x, long int y);

void update_position(void);

float get_heading(void);

float convertToPositiveAngle(float a);

float getShortestAngle(float a1,float a2);

float getBestAngleTurn();

float heading_select();


#endif