#include <joyos.h>

void init_nodes() {
	float angle = 0;
	float len = 0;
	float a2 = 0;
	for ( int i = 0; i < 6; i++ ) {
		//TERRITORY_CITY
		nodes[N_TERRITORY_POINTS*i+TERRITORY_CITY].x = 800*cos(angle);
		nodes[N_TERRITORY_POINTS*i+TERRITORY_CITY].y = 800*sin(angle);
		//TERRITORY_CENTER
		nodes[N_TERRITORY_POINTS*i+TERRITORY_CENTER].x = 1245*cos(angle);
		nodes[N_TERRITORY_POINTS*i+TERRITORY_CENTER].y = 1245*sin(angle);
		
		///////////TERRITORY_GEARBOX_APPROACH
		nodes[N_TERRITORY_POINTS*i+TERRITORY_GEARBOX_APPROACH].x = 1550*cos(angle);
		nodes[N_TERRITORY_POINTS*i+TERRITORY_GEARBOX_APPROACH].y = 1550*sin(angle);


		///////////TERRITORY_GEARBOX 							
		len = 1560;//old1600; //really old1492.26; 
		a2 = 8.90*M_PI/180.; //8.20*M_PI/180.;  //9.92*M_PI/180.; 
		nodes[N_TERRITORY_POINTS*i+TERRITORY_GEARBOX].x = len*cos(angle+a2);
		nodes[N_TERRITORY_POINTS*i+TERRITORY_GEARBOX].y = len*sin(angle+a2);	
		////////////TERRITORY_LEVER
		len = 1570.;  //the distance from center to 1600, 300  because jake is stupid
		a2 = atan(300./1600.);	
		nodes[N_TERRITORY_POINTS*i+TERRITORY_LEVER].x = len*cos(angle-a2);
		nodes[N_TERRITORY_POINTS*i+TERRITORY_LEVER].y = len*sin(angle-a2);
		////////////
		
		angle += M_PI/3.0; //rotate 60 degrees
		
	}
	//testing

	//nodes[N_TERRITORY_POINTS*3+TERRITORY_GEARBOX].x = 1530*cos(M_PI+7.00*M_PI/180.);
	//nodes[N_TERRITORY_POINTS*3+TERRITORY_GEARBOX].y = 1530*sin(M_PI+7.00*M_PI/180.);

	nodes[N_TERRITORY_POINTS*6].x = 0;
	nodes[N_TERRITORY_POINTS*6].y = 0;

	//endtesting
}

//Uses *G*E*O*M*E*T*R*Y* to calculate which territory a point is in
int point_get_territory(long int _x,long int _y) {
      if ( _x >= 0 ) {
            if ( _y < -_x/sqrt(3) ) { return 5; }
            else if ( _y < _x/sqrt(3) ) { return 0; }
            else { return 1; }
      }
      else {
            if ( _y < _x/sqrt(3) ) { return 4; }
            else if ( _y < -_x/sqrt(3) ) { return 3; }
            else { return 2; }
      }
}

float get_gearbox_angle( int _territory ) {
	switch ( _territory ) {
		case 0: return 120.;
		case 1: return 180.;
		case 2: return -120.;
		case 3: return -60.;
		case 4: return 0;
		case 5: return 60.0;
	}
	return -1.0;
}

float get_lever_angle( int _territory ) {
	switch ( _territory ) {
		case 0: return -30.0;
		case 1: return 30.0;
		case 2: return 90.0;
		case 3: return 150.0;
		case 4: return -150.0;
		case 5: return -90.0;
	}
	return -1.0;
}

float get_dump_angle( int _territory ) {
	switch ( _territory ) {
		case 0: return 0.0;
		case 1: return 60.0;
		case 2: return 120.0;
		case 3: return 180.0;
		case 4: return -120.0;
		case 5: return -60.0;
	}
	return -1.0;
}

int territory_index( int _territory ) {
	return _territory*N_TERRITORY_POINTS;
}

int my_current_territory() {
	return point_get_territory((long int)me.x,(long int)me.y);
}
int enemy_current_territory() {
	return point_get_territory((long int)game.coords[1].x,(long int)game.coords[1].y);
}

int point_type( int _index ) {
	return _index % N_TERRITORY_POINTS;
}

int point_territory( int _index ) {
	return _index/N_TERRITORY_POINTS; //integer division
}