#include <joyos.h>


//int16_t timesRun = 0;
uint8_t ballsRemaining = 0;
uint32_t timeoutVar = 0;
int oldBalls = 0;
int oldPoint = -1;
int failCount = 0;

long int oldMeX;
long int oldMeY;

///////////////////// COMMAND ISSUEING FUNCTIONS //////////////////////
void set_command_idle() {
	acquire(&current_command_lock);
	//printf("inside idle\n");
	newCommand = 1;
	currentCommand.type = IDLE;
	release(&current_command_lock);

	while(newCommand){pause(10); }

}
void set_command_capture() {	
	acquire(&current_command_lock);
	//printf("inside capture\n");
	newCommand = 1;
	currentCommand.type = CAPTURE;
	timeoutVar = get_time();
	release(&current_command_lock);

	while(newCommand){pause(10);  }

}
void set_command_heading( float _angle ) {
	acquire(&current_command_lock);
	//printf("inside heading\n");
	newCommand = 1;
	currentCommand.type = TURNING;
	currentCommand.heading = _angle;
	headingSelect = true;
	dir.forward = false;

	timeoutVar = get_time();

	recalibrate();

	////printf("turning towards currentCommand.heading: %f _angle: %f   they should be the same\n", currentCommand.heading, _angle);

	goal.theta = _angle;
	update_pid(&headingPID);
	release(&current_command_lock);

	while(newCommand){pause(10);  }

}
void set_command_face_point( int _nodeIndex ) {
	acquire(&current_command_lock);
	//printf("inside facing\n");
	newCommand = 1;
	currentCommand.type = FACING;
	currentCommand.x = nodes[_nodeIndex].x;
	currentCommand.y = nodes[_nodeIndex].y;
	currentCommand.pointInfo = _nodeIndex;	

	timeoutVar = get_time();

	//printf("update_all command\n");
	update_all(currentCommand.x, currentCommand.y);

	release(&current_command_lock);

	while(newCommand){pause(10);}

}
void set_command_point( int _nodeIndex ) {
	acquire(&current_command_lock);
	//printf("inside go to point\n");
	newCommand = 1;
	currentCommand.type = MOVING;
	currentCommand.x = nodes[_nodeIndex].x;
	currentCommand.y = nodes[_nodeIndex].y;
	currentCommand.pointInfo = _nodeIndex;

		timeoutVar = get_time();
		failCount= 0;

	update_all(currentCommand.x, currentCommand.y);

	oldMeX = me.x;
	oldMeY = me.y;

	release(&current_command_lock);

	while(newCommand){pause(10);  }

}

void set_command_pull_lever(int _territory){	
	acquire(&current_command_lock);
	//printf("inside pull\n");
	ballsRemaining = game.territories[_territory].remaining;
	newCommand = 1;
	currentCommand.type = PULL;
	servo_set_pos(1, 60);

		timeoutVar = get_time();
	release(&current_command_lock);


	while(newCommand){pause(10);}

}

void set_command_dump(void){
	acquire(&current_command_lock);
	newCommand = 1;
	currentCommand.type = DUMP;
	//printf("inside dump\n");

	dumping = true;
	release(&current_command_lock);

	while(newCommand){pause(10);}
}

int big_dump(int territoryIndex){

	set_command_heading( get_dump_angle(territoryIndex));

	while( !reached_heading() ) { pause(10); }

	set_command_idle();

	set_command_dump();

	while( !done_dump() ) { pause(10); }

	set_command_idle();

	nBallsCollected = 0;

	return 1;
}
int balls(int territoryIndex){

	//printf("balls\n");
	set_command_heading( get_lever_angle(territoryIndex));

	while( !reached_heading() ) { pause(10); }

	set_command_idle();

	//printf("balls lever\n");
	set_command_pull_lever(territoryIndex);

	while(!pull_success()){pause(10); }

	set_command_idle();
return 1;
}


int turn_and_move( int _nodeIndex ) {

				//only turn if necessary
	//printf("set command face point\n");
	set_command_face_point(_nodeIndex);
	//printf("end set command face point\n");
	
	while( !reached_heading() ) { pause(10);}
	//printf("reached heading\n");
		
	//printf("set idle in turn and move\n");
	set_command_idle();
	

	//printf("end idle\n");

	//printf("set command point\n");
	set_command_point(_nodeIndex);
	//printf("end set command point\n");
	while( !reached_point() ) { pause(10); }
	//printf("point reached\n");

	set_command_idle();
	return 1;
}

int capture(int _territoryIndex){

	set_command_heading(to_degrees((float) atan2((double) (nodes[_territoryIndex*N_TERRITORY_POINTS + TERRITORY_GEARBOX].y-me.y), (double) (nodes[_territoryIndex*N_TERRITORY_POINTS + TERRITORY_GEARBOX].x-me.x))));

	while( !reached_heading() ) { pause(10); }

	set_command_idle();


	turn_and_move(_territoryIndex*N_TERRITORY_POINTS + TERRITORY_GEARBOX);



	set_command_heading(get_gearbox_angle(_territoryIndex));

	while( !reached_heading() ) { pause(10); }

	set_command_idle();



	set_command_capture();

	while( !territory_captured(_territoryIndex) ) { pause(10);   }

	set_command_idle();
	return 1;
}



/////////////////////// GOAL CONDITIONS ///////////////////////////
int reached_heading() {

	if (fabs(getHeadingErr()) < MIN_ERROR_HEADING) {

		/*   UNCOMMENT IF tuRNIng BECOMES AN ISSUE AGAIN
		if(	currentCommand.type == CAPTURE || currentCommand.type == TURNING || currentCommand.type == FACING){
		pause(100);
		if (fabs(getHeadingErr()) < MIN_ERROR_HEADING_CAPTURE) {
		motor_set_vel(0,0);
		motor_set_vel(1,0);

		printf("heading reached flagged in a capture\n");
		return 1; //reached heading	
		}else{
		return 0;
		}

		}
		*/

		//printf("heading reached flagged\n");
		return 1; //reached heading	
	}
/*
	if(timeoutVar +4000 < get_time()){
		printf("heading timeout\n");
		set_command_idle();
		recalibrate();
		if(currentCommand.type == TURNING){
			printf("heading timeout: heading\n");
			set_command_heading(currentCommand.heading);

		}else if(currentCommand.type == FACING){
			printf("heading timeout:face\n");
			set_command_face_point(currentCommand.pointInfo);

		}
		timeoutVar = get_time();
	}*/
	//printf("haven't yet reached heading\n");
	return 0; //haven't reached heading
}
int reached_point() {
	if(((currentCommand.pointInfo) % N_TERRITORY_POINTS) == TERRITORY_CENTER &&  line_dist() < CENTER_DIST_ERR ){  //different tolerance if just going to centers
		
		for(int i =0; i<6; i++){
			digital_write(i, 1);
		}
		pause(100);
		for(int i =0; i<6; i++){
			digital_write(i, 0);
		}
		return 1; //reached point for center
	}else if ( line_dist() < 37 && ((currentCommand.pointInfo) % N_TERRITORY_POINTS) != TERRITORY_GEARBOX) {  
		//printf("point reached flagged\n");
		return 1; //reached point for elsewhere
	}else if( line_dist() < 25 && ((currentCommand.pointInfo) % N_TERRITORY_POINTS) == TERRITORY_GEARBOX){
		return 1;
	}else{

		//printf("point not yet reached\n");
		return 0;//haven't reached point 
	}

}
int territory_captured(int _territory) { 
	copy_objects();
	if(game.territories[_territory].owner == 8){ //timesRun == 100) {
		//timesRun = 0;
		return 1;
	}

	if (timeoutVar + 5000 < get_time()){  //timeout for capture
		printf("timed out arm\n");
		int	territoryIndex = point_get_territory(me.x, me.y);
		set_command_idle();
		recalibrate();
		printf("timed out arm: done recalibrating\n");

		printf("timed out arm: back to approach\n");
		turn_and_move(  territoryIndex * N_TERRITORY_POINTS + TERRITORY_GEARBOX_APPROACH );

		printf("timed out arm: back to gearbox\n");
		turn_and_move( territoryIndex * N_TERRITORY_POINTS + TERRITORY_GEARBOX );


		set_command_heading(get_gearbox_angle(territoryIndex));

		while( !reached_heading() ) { pause(10); }

		set_command_idle();

		set_command_capture();
		printf("timed out arm: keep trying with a reset timer\n");

		timeoutVar = get_time();
		return 0;

	}


	//timesRun++;
	return 0; //territory not captured
}

int done_dump(void){
	while(dumping){
		for(int i = 0; i<2; i++){
			digital_write(i, 1);
			pause(20);
		}
		for(int i = 0; i<4; i++){
			digital_write(i+2, 1);
			digital_write(i, 0);
			pause(20);
		}
		for(int i = 4; i<6; i++){
			digital_write(i, 0);
			pause(20);
		}
		return 0;

	}
	return 1;
}


int pull_success(void){ 
	copy_objects();
	if(game.territories[point_get_territory(me.x, me.y)].remaining == 0){
		printf("rate limit exceeded!\n");
		set_command_idle();
		pause(10);
		update_position();
		gyro_set_degrees(map((float)((long int) game.coords[0].theta),-2048.,2047.,-179.,180.));
		pause(10);
		printf("backin' on up for safety\n");
		motor_set_vel(0, 200);
		motor_set_vel(1, 200);
		pause(200);
		motor_set_vel(0,0);
		motor_set_vel(1,0);

		return 1;
	}

	if (oldBalls != nBallsCollected){
		timeoutVar = get_time();
		printf("got one, reset timeout\n");
	}else if(timeoutVar + 10000 < get_time()){
		printf("pull timeout activated\n");

		int	territoryIndex = point_get_territory(me.x, me.y);
		printf("pull timeout idle\n");
		set_command_idle();
		printf("pull timeout turn and move\n");
		turn_and_move(territoryIndex * N_TERRITORY_POINTS + TERRITORY_LEVER );
		printf("pull timeout heading\n");
		set_command_heading( get_lever_angle(territoryIndex));
		while( !reached_heading() ) { pause(10); }
		printf("pull timeout idle2\n");
		set_command_idle();
		printf("pull timeout pull lever\n");
		set_command_pull_lever(territoryIndex);

		timeoutVar = get_time();

	}

	oldBalls = nBallsCollected ;

	return 0;
}

////////////////////////////////////////////////////////////////////

//given two territories
//returns smallest number of territories between them
float get_territory_difference(int t1,int t2) {
	int t = abs(t1-t2) % 6;
	if ( t > 3 ) {
		t = 6-t;
	}
	return t;
}

int pathfind_to_point( int _currentIndex, int _goalIndex ) {

	if ( _currentIndex == _goalIndex ) { //pathfinding to point already at
		return 1;
	}

	int currentTerritory = (int)(_currentIndex/N_TERRITORY_POINTS); //should round down, give # of times N_TERRITORY_POINTS fits into _currentIndex
	int goalTerritory = (int)(_goalIndex/N_TERRITORY_POINTS);
	int currentPointType = _currentIndex % N_TERRITORY_POINTS;
	int goalPointType = _goalIndex % N_TERRITORY_POINTS;


	//printf("ct: %d gt:%d cpt: %d gpt: %d ci: %d gi: %d\n", currentTerritory, goalTerritory, currentPointType, goalPointType, _currentIndex, _goalIndex);
	if ( currentPointType != TERRITORY_CENTER ) {
		//go to territory center
		//printf("move first to territory center\n");
		turn_and_move( currentTerritory*N_TERRITORY_POINTS+TERRITORY_CENTER );
		//printf("done moving to territory center\n");
	}
	if ( currentTerritory != goalTerritory ) {
		//move to territory centers until reach goal territory
		int territoriesAway = get_territory_difference(currentTerritory,goalTerritory);
		int territoryDirection = (get_territory_difference(currentTerritory+1,goalTerritory)>territoriesAway) ? -1 : 1; //tertiary just for you ryan
		int nextTerritory = currentTerritory;
		//printf("Away: %d Direction: %d\n", territoriesAway, territoryDirection);
		for ( int i = 0; i < territoriesAway; i++ ) {
			//printf("Number of territories moved to: %d\n", i);
			nextTerritory += territoryDirection;
			if ( nextTerritory >= 6 ) {
				nextTerritory = 0;
			}
			if ( nextTerritory < 0 ) {
				nextTerritory = 5;
			}
			//printf("next: %d\n", nextTerritory);
			//go to point nextTerritory+TERRITORY_CENTER
			//printf("going to the next territory\n");
			turn_and_move(nextTerritory*N_TERRITORY_POINTS + TERRITORY_CENTER );
			//printf("at next territory, pathfinding either done or moving again\n");

		}

	}
	if ( goalPointType != TERRITORY_CENTER ) {
		//go to goal point

		//printf("moving to specific point\n");
		turn_and_move( _goalIndex );
		//printf("done moving to specific point\n");
	}
	return 1;
}

////////////////////////////////////////////////////////////////////
// Strategy function - function for strategy thread
// where high level strategy decision come out of
////////////////////////////////////////////////////////////////////
int strategy() {
	//printf("strategy begin\n");


/*
	if (team){

		pathfind_to_point(TERRITORY_0 + TERRITORY_CENTER, TERRITORY_2 + TERRITORY_CENTER);

		pause(200);
		copy_objects();
		gyro_set_degrees(map((float)((long int) game.coords[0].theta),-2048.,2047.,-179.,180.));
		pause(20);

		pathfind_to_point(TERRITORY_2 + TERRITORY_CENTER, TERRITORY_4 + TERRITORY_CENTER);

		pause(200);
		copy_objects();
		gyro_set_degrees(map((float)((long int) game.coords[0].theta),-2048.,2047.,-179.,180.));
		pause(20);

		//printf("set pathfind to point0\n");
		pathfind_to_point(TERRITORY_4 + TERRITORY_CENTER, TERRITORY_5 + TERRITORY_GEARBOX_APPROACH);
		//printf("end set pathfind0\n");

		capture(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_GEARBOX, TERRITORY_5 + TERRITORY_LEVER);
		balls(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_LEVER, TERRITORY_0 + TERRITORY_GEARBOX_APPROACH);

		capture(0);

		pathfind_to_point(TERRITORY_0 + TERRITORY_GEARBOX, TERRITORY_0 + TERRITORY_LEVER);

		balls(0);

		pathfind_to_point(TERRITORY_0 + TERRITORY_LEVER, TERRITORY_1 + TERRITORY_GEARBOX_APPROACH);

		capture(1);

		pathfind_to_point(TERRITORY_1 + TERRITORY_GEARBOX, TERRITORY_1 + TERRITORY_LEVER);

		balls(1);

		pathfind_to_point(TERRITORY_1 + TERRITORY_LEVER, TERRITORY_2 + TERRITORY_GEARBOX_APPROACH);

		capture(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_GEARBOX, TERRITORY_2 + TERRITORY_LEVER);

		balls(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_LEVER, TERRITORY_2 + TERRITORY_CITY);

		big_dump(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_CITY, TERRITORY_3 + TERRITORY_GEARBOX_APPROACH);
		capture(3);

		pathfind_to_point(TERRITORY_3 + TERRITORY_GEARBOX, TERRITORY_3 + TERRITORY_LEVER);
		balls(3);

		pathfind_to_point(TERRITORY_3 + TERRITORY_LEVER, TERRITORY_3 + TERRITORY_CITY);

		big_dump(3);

		pathfind_to_point(TERRITORY_3 + TERRITORY_LEVER, TERRITORY_4 + TERRITORY_GEARBOX_APPROACH);
		capture(4);

		pathfind_to_point(TERRITORY_4 + TERRITORY_GEARBOX, TERRITORY_4 + TERRITORY_LEVER);
		balls(4);

		pathfind_to_point(TERRITORY_4 + TERRITORY_LEVER, TERRITORY_5 + TERRITORY_GEARBOX_APPROACH);
		capture(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_GEARBOX, TERRITORY_5 + TERRITORY_LEVER);
		balls(5);

	}else{

		//pathfind_to_point(TERRITORY_3 + TERRITORY_CENTER, TERRITORY_5 + TERRITORY_CENTER);

pathfind_to_point(TERRITORY_3 + TERRITORY_CENTER, TERRITORY_5 + TERRITORY_CENTER);


		pause(200);
		copy_objects();
		gyro_set_degrees(map((float)((long int) game.coords[0].theta),-2048.,2047.,-179.,180.));
		pause(20);

pathfind_to_point(TERRITORY_5 + TERRITORY_CENTER, TERRITORY_1 + TERRITORY_CENTER);


		pause(200);
		copy_objects();
		gyro_set_degrees(map((float)((long int) game.coords[0].theta),-2048.,2047.,-179.,180.));
		pause(20);

pathfind_to_point(TERRITORY_1 + TERRITORY_CENTER, TERRITORY_2 + TERRITORY_GEARBOX_APPROACH);

		capture(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_GEARBOX, TERRITORY_2 + TERRITORY_LEVER);

		balls(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_LEVER, TERRITORY_3 + TERRITORY_GEARBOX_APPROACH);

		capture(3);

		pathfind_to_point(TERRITORY_3 + TERRITORY_GEARBOX, TERRITORY_3 + TERRITORY_LEVER);
		balls(3);

		pathfind_to_point(TERRITORY_3 + TERRITORY_LEVER, TERRITORY_4 + TERRITORY_GEARBOX_APPROACH);
		capture(4);

		pathfind_to_point(TERRITORY_4 + TERRITORY_GEARBOX, TERRITORY_4 + TERRITORY_LEVER);
		balls(4);

		pathfind_to_point(TERRITORY_4 + TERRITORY_LEVER, TERRITORY_4 + TERRITORY_CITY);

		big_dump(4);

		pathfind_to_point(TERRITORY_4 + TERRITORY_LEVER, TERRITORY_5 + TERRITORY_GEARBOX_APPROACH);
		capture(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_GEARBOX, TERRITORY_5 + TERRITORY_LEVER);
		balls(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_LEVER, TERRITORY_5 + TERRITORY_CITY);

		big_dump(5);

		pathfind_to_point(TERRITORY_5 + TERRITORY_LEVER, TERRITORY_0 + TERRITORY_GEARBOX_APPROACH);

		capture(0);

		pathfind_to_point(TERRITORY_0 + TERRITORY_GEARBOX, TERRITORY_0 + TERRITORY_LEVER);

		balls(0);

		pathfind_to_point(TERRITORY_0 + TERRITORY_LEVER, TERRITORY_1 + TERRITORY_GEARBOX_APPROACH);

		capture(1);

		pathfind_to_point(TERRITORY_1 + TERRITORY_GEARBOX, TERRITORY_1 + TERRITORY_LEVER);

		balls(1);

		pathfind_to_point(TERRITORY_1 + TERRITORY_LEVER, TERRITORY_2 + TERRITORY_GEARBOX_APPROACH);

		capture(2);

		pathfind_to_point(TERRITORY_2 + TERRITORY_GEARBOX, TERRITORY_2 + TERRITORY_LEVER);

		balls(2);
	}

	*/




//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////      STRATEGY      ////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	int currentTerritory = ( team == BLUE ) ? 0 : 3;
	int dropTerritory = ( team == BLUE ) ? 2 : 5;
	int nextTerritory = currentTerritory;
	int exploreDir = 1; //CCW
	int currentPoint = 0;
	int nextPoint = 0;
	int changeTerritory = 0;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////	FIRST 10 SECONDS OF EXPLORATION
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	while ( getMatchTime() < (10*1000) ) {

		nextTerritory = currentTerritory + exploreDir;
		
		if ( nextTerritory < 0 ) { nextTerritory = 5; }
		else if ( nextTerritory > 5 ) { nextTerritory = 0; }

		if ( enemy_current_territory() == nextTerritory ) {
			//enemy in that territory!, turn around!
			exploreDir = ( exploreDir == 1 ) ? -1 : 1;
			continue;
		}

		if ( pathfind_to_point(territory_index(currentTerritory) + TERRITORY_CENTER, territory_index(nextTerritory) + TERRITORY_CENTER) == 0 ) {
			//if pathfinding wasn't successful, try turning around
			exploreDir = ( exploreDir == 1 ) ? -1 : 1;
			nextTerritory = currentTerritory;
			continue;
		}
		currentTerritory = nextTerritory;
		
		pause( 10 );
		
	}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////// REST OF MATCH
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// FIRST 10 SECONDS LOOP SHOULD HAVE LEFT currentPoint AT THE TERRITORY WHERE WE ARE
	currentPoint = territory_index(currentTerritory)+TERRITORY_CENTER;
	
	// WHILE IT'S NOT THE LAST 10 SECONDS DROPPING SEQEUNCE ( CHECKS THAT WE ACTUALLY HAVE BALLS )
	while ( !(   (( getMatchTime()/1000) > (110) ) && ( nBallsCollected > 0 )   ) ) {
	
		if ( nBallsCollected > 10 ) {
		
			//CURRRENTLY NO ERROR HANDLING FOR THISS :(
			
			// MOVE TO DROP TERRITORY'S CENTER
			nextPoint = territory_index( dropTerritory )+TERRITORY_CITY;
			if ( pathfind_to_point( currentPoint, nextPoint ) == 0 ) {
				// STUCK SOMEWHERE
				// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
			}
			currentPoint = nextPoint;
			
			//DROP
			big_dump( dropTerritory );
			currentPoint = territory_index( dropTerritory )+TERRITORY_CITY;
			
			// nBallsCollected SHOULD NOW BE RESET AND THINGS CONTINUE
			
		}
		else {
		
			changeTerritory = 1;
			
			if ( game.territories[point_territory(currentPoint)].owner != 8 && ( enemy_current_territory() == point_territory(currentPoint))) {

				changeTerritory = 1;
				exploreDir = ( exploreDir == 1 ) ? -1 : 1;

			}else if ( game.territories[point_territory(currentPoint)].owner != 8 ) {

			
				// **** GEARBOX ****
				// TERRITORY NOT OURS, CAPTURE
				
				nextPoint = territory_index(point_territory(currentPoint))+TERRITORY_GEARBOX_APPROACH;
				if ( pathfind_to_point( currentPoint, nextPoint ) == 0 ) {
					// STUCK SOMEWHERE
					// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
				}
				currentPoint = nextPoint;
				
				if ( capture( point_territory(currentPoint) ) == 0 ) {
					// FAILURED CAPTURE
					// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
				}
				currentPoint = territory_index(point_territory(currentPoint))+TERRITORY_GEARBOX;
				changeTerritory = 0;
				
			}
			else if ( game.territories[point_territory(currentPoint)].remaining > 0 ) {
			
				// **** LEVER ****
				// ALREADY CAPTURED, GET BALLS
				
				nextPoint = territory_index(point_territory(currentPoint))+TERRITORY_LEVER;
				if ( pathfind_to_point( currentPoint, nextPoint ) == 0 ) { //failure
					// STUCK SOMEWHERE
					// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
				}
				currentPoint = nextPoint;
				
				if ( balls( point_territory(currentPoint) ) == 0 ) {
					// GETTING BALLS FAILED
					// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
				}
				currentPoint = territory_index(point_territory(currentPoint))+TERRITORY_LEVER;
				changeTerritory = 0;
				
			}
			if ( changeTerritory == 1 ) {
			
				// ALREADY CAPTURED AND GOT BALLS OR SOMETHING WENT WRONG
				// GO TO A DIFFERENT TERRITORY
				
				nextTerritory = point_territory(currentPoint)+exploreDir;
				
				if ( nextTerritory < 0 ) { nextTerritory = 5; }
				else if ( nextTerritory > 5 ) { nextTerritory = 0; }

				if ( enemy_current_territory() == nextTerritory ) {
					//enemy in that territory!, turn around!
					exploreDir = ( exploreDir == 1 ) ? -1 : 1;
					continue;
				}

				nextPoint = territory_index(nextTerritory) + TERRITORY_CENTER;
				
				if ( pathfind_to_point( currentPoint,  nextPoint) == 0 ) {
					// STUCK SOMEWHERE
					// REACT & BREAK LOOP, err maybe not break but don't want to continue this loop
				}
				currentPoint = nextPoint;
				
			}
		}
		
		pause( 10 );
	
	}
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////// LAST 10 SECONDS, D-D-D-DROP DEM BALLZZZ
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	nextPoint = territory_index(dropTerritory)+TERRITORY_CENTER;
	pathfind_to_point(currentPoint,nextPoint);
	currentPoint = nextPoint;
	
	big_dump( dropTerritory );
	
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////       END OF STRATEGY      //////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	

	//printf("set command idle\n");
	set_command_idle();
	//printf("end set command idle");

	for (;;) { 
		pause(10);
		printf("still idling\n");
		yield();
	}

	return 0;
}